package nl.esi.metis.aisparser;

public class HandlerAIVDMLine implements IHandleAIVDMLine {

	private IHandleAIVDMMessage handler;
	public HandlerAIVDMLine(IHandleAIVDMMessage handler)
	{
		this.handler = handler;
	}

	private AIVDMMessage current = null;
	public void handleAIVDMLine(AIVDMLine line) {
		if(current == null)
		{
			current = new AIVDMMessage(line);
		}
		else
		{
			if (current.isPartOfMessage(line))
			{
				current.add(line);
			}
			else
			{
				//System.out.println("Partial message "+ current.getProvenance().getProvenanceTree(""));

				current = new AIVDMMessage(line);
			}
		}

		if(current.atEnd())
		{
			if (current.isComplete())
			{
				handler.handleAIVDMMessage(current);
			}
			else
			{
				//System.out.println("Partial message "+ current.getProvenance().getProvenanceTree(""));
			}
			current = null;
		}
	}
	
	public void finished() {
		if(current != null)
		{
			System.out.println("Partial message "+ current.getProvenance().getProvenanceTree(""));
			//TODO: must finished message be passed on even further?
		}
	}
}
