package nl.esi.metis.aisparser;

public class HandlerAIVDMMessage implements IHandleAIVDMMessage {

	private IHandleAISMessage handler;
	public HandlerAIVDMMessage(IHandleAISMessage handler)
	{
		this.handler = handler;
	}

	public AISMessage GetMessage(Sixbit sb, Provenance prov)
	{
		if (sb.length() < 38)
		{
			AISMessage retval = new AISMessageIllegalImpl(sb, prov);
			System.err.println("Impossible length "+sb.length()+". All messages start with 38 bits (messageId, repeatIndicator, and UserID). "+ retval.toString());
			return retval;
		}
		else
		{
			int messageid 			= AISMessageImpl.getMessageID(sb);
			switch (messageid)
			{
			case 1:
				if (! AISMessage01Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage01Impl(sb, prov);
			case 2:
				if (! AISMessage02Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage02Impl(sb, prov);
			case 3:
				if (! AISMessage03Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage03Impl(sb, prov);
			case 4:
				if (! AISMessage04Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage04Impl(sb, prov);
			case 5:
				if (! AISMessage05Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage05Impl(sb, prov);
			case 6:
				if (! AISMessage06Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage06Impl(sb, prov);
			case 7:
				if (! AISMessage07Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage07Impl(sb, prov);
			case 8:
				if (! AISMessage08Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage08Impl(sb, prov);
			case 9:
				if (! AISMessage09Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage09Impl(sb, prov);
			case 10:
				if (! AISMessage10Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage10Impl(sb, prov);
			case 11:
				if (! AISMessage11Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage11Impl(sb, prov);
			case 12:
				if (! AISMessage12Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage12Impl(sb, prov);
			case 13:
				if (! AISMessage13Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage13Impl(sb, prov);
			case 14:
				if (! AISMessage14Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage14Impl(sb, prov);
			case 15:
				if (! AISMessage15Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage15Impl(sb, prov);
			case 16:
				if (! AISMessage16Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage16Impl(sb, prov);
			case 17:
				if (! AISMessage17Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage17Impl(sb, prov);
			case 18:
				if (! AISMessage18Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage18Impl(sb, prov);
			case 19:
				if (! AISMessage19Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage19Impl(sb, prov);
			case 20:
				if (! AISMessage20Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage20Impl(sb, prov);
			case 21:
				if (! AISMessage21Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage21Impl(sb, prov);
			case 22:
				if (! AISMessage22Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage22Impl(sb, prov);
			case 23:
				if (! AISMessage23Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage23Impl(sb, prov);
			case 24:
			    {
			    	// Distinguish between the different part numbers:
			    	if (AISMessage24PartAImpl.valid(sb))
					{
						return new AISMessage24PartAImpl(sb, prov);
					}
					else if (AISMessage24PartBImpl.valid(sb))
					{
						return new AISMessage24PartBImpl(sb, prov);
					}
					else
					{
						return new AISMessageInconsistentImpl(sb, prov);
					}
			    }
			case 25:
				if (! AISMessage25Impl.valid(sb))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage25Impl(sb, prov);
			case 26:
				if (! AISMessage26Impl.valid(sb))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage26Impl(sb, prov);
			case 27:
				if (! AISMessage27Impl.validLength(sb.length()))
				{
					return new AISMessageInconsistentImpl(sb, prov);
				}
				return new AISMessage27Impl(sb, prov);
			default:
				return new AISMessageUnknownMessageIdImpl(sb, prov);
			}
		}
	}
	public void handleAIVDMMessage(AIVDMMessage message) {
		Sixbit sb = new Sixbit(message.getMessage(), message.nrOfFillBits());
		Provenance provenance = message.getProvenance();
		AISMessage aisMessage = GetMessage(sb, provenance);
		handler.handleAISMessage(aisMessage);
	}
}
