package nl.esi.metis.aisparser;

public class HandlerLine implements IHandleLine {
	private IHandleAIVDMLine handler;
	public HandlerLine(IHandleAIVDMLine handler)
	{
		this.handler = handler;
	}

	public void handleLine(Provenance p, String line) {
		AIVDMLine a = new AIVDMLine(p,line);
		if (a.isValid())
		{
			handler.handleAIVDMLine(a);
		}
		else
		{
			System.out.println("Invalid Line from " + p.getProvenanceTree("")+ " - " + line);
		}
	}
	
	public void finished() {
		handler.finished();
	}
}
